var messageBodies =	[
  "<p>Reload the page or try again later.</p>", // General, non-discriptive message
	"<p>3D map could not be created. Reload the page or try again later.</p>",
	"<p>Camera controls could not be loaded. Reload the page or try again later.</p>",
	"<p>The 3D map could not be created. Reload the page or try again later.</p>"
]

var errMsg = document.getElementById("errorMsg");

//  @brief - Displays an error message for the user if the 3D map fails to display
//    Function can be used by sending it an object and a message or index. If the object
//      is null, the message is displayed. The message index decides which message to display.
//
//  @param obj  - An object to check if is null
//  @param msg  - The index for the message to display, or a custom message
function errorCheck(obj, msg)	{
  var messageHeader = "<h1>An error occurred</h1>";
  if (!obj) {
    errMsg.innerHTML = messageHeader + 
    (!isNaN(msg)  // If msg value is an index (number)
      ? ((
        msg < messageBodies.length)
        ? messageBodies[msg] // Is valid index
        : "<p>Unknown error</p>") // Is invalid index
      : msg); // msg is not a number
  }
}

function displayLoadingIcon (isLoading, message)  {
  var loadingDiv = document.getElementById("loadingDiv");
  var loadingText = document.getElementById("loadingText");
  if (isLoading)  {
    loadingDiv.style.display="inline-block";
    loadingText.innerHTML=message;
  }
  else {
    loadingDiv.style.display = "none";
    loadingText.innerHTML="";
  }
}

