// extraction for URL parameters
function getQueryVariable(variable) {
	//console.log('Kjører: universe.js - getQueryVariable')
  var pair, i;
  var query = window.location.search.substring(1);
  //console.log(window.location.search.substring(1))
  var vars = query.split("&");
  for (i = 0; i < vars.length; i = i + 1) {
    pair = vars[i].split("=");
	//console.log("var: " + pair);
    if (pair[0].toUpperCase() === variable) {
      console.log("getQueryVariable: " + pair);
	  return pair[1];
    }
  }
  return false;
}

// check WebGL
if (!window.WebGLRenderingContext) {
  // the browser doesn't even know what WebGL is
  window.location = "http://get.webgl.org";
}

// utility func to convert dict of {key: "val", key2: "val2"} to key=val&key2=val2
function urlformat(values) {
  var res = [], key;
  for (key in values) {
    if (values.hasOwnProperty(key)) {
      res.push(key + '=' + values[key]);
    }
  }
  return res.join('&');
}

// TODO: Update this to allow for wmts, variable wcs ++
Dim = {
  width: window.innerWidth,   // Set to width of window
  height: window.innerHeight, // Set to height of window
  bbox: getQueryVariable("BBOX") || '121877.96875,6944612.78125,128224.84375,6950959.65625',//Troll
  //bbox: getQueryVariable("BBOX") || '261244,6744251,271526,6750409',//Gjøvik
  //bbox: getQueryVariable("BBOX") || '161244,6831251,171526,6837409',//Jotunheimen
  minx: 0,
  maxx: 0,
  miny: 0,
  maxy: 0,
  Z:0,
  getBounds: function () {
    return {
      minx: this.minx,
      miny: this.miny,
      maxx: this.maxx,
      maxy: this.maxy
    };
  },
  init: function () {
    var splitBbox = this.bbox.split(',');
    this.metersWidth = splitBbox[2] - splitBbox[0];
    this.metersHeight = splitBbox[3] - splitBbox[1];
    this.minx = parseInt(splitBbox[0], 10);
    this.maxx = parseInt(splitBbox[2], 10);
    this.miny = parseInt(splitBbox[1], 10);
    this.maxy = parseInt(splitBbox[3], 10);

    if (getQueryVariable("WMSFORMATMODE")) {
      this.wmsFormatMode = '; mode=' + getQueryVariable("WMSFORMATMODE");
    }
    return this;
  },
  crs: getQueryVariable("CRS") || getQueryVariable("SRS") || '25833',
  //crs: getQueryVariable("CRS") || getQueryVariable("SRS") || '32633',
  coverage: getQueryVariable("COVERAGE") || 'land_utm33_10m',
  //coverage: getQueryVariable("COVERAGE") || 'dtm_25832',
  //wmsUrl: getQueryVariable("WMS") || 'http://openwms.statkart.no/skwms1/wms.nib',
  wmsUrl: getQueryVariable("WMS") || false,
  wmtsLayer: getQueryVariable("LAYER") || 'topo4',
  wmsLayers: getQueryVariable("LAYERS") || 'ortofoto',
  wmtsUrl: getQueryVariable("WMTS") || 'https://opencache.statkart.no/gatekeeper/gk/gk.open_wmts',
  wmscUrl:  getQueryVariable("WMSC") || 'https://opencache.statkart.no/gatekeeper/gk/gk.open_cache',
  wcsUrl: getQueryVariable("WCS")||'https://wms.geonorge.no/skwms1/wcs.dtm',
  //wcsUrl: getQueryVariable("WCS")||'https://wms.geonorge.no/skwms1/wcs.hoyde-dtm-nhm-25832',
  wmsFormat: getQueryVariable("WMSFORMAT") || "image/png",
  wmsFormatMode: "",
  gatekeeperTicket: getQueryVariable("GKT")||false,
  zMult: getQueryVariable("ZMULT") || 1
};

var dim = Dim.init();
console.log(dim);

/*if (dim.wmtsLayer=="Nibcache_UTM33_EUREF89_v2"){
	console.log('Feil!\nUrl: ' + dim.wmtsUrl + '\nLayer: ' + dim.wmtsLayer);
	dim.wmtsUrl='https://opencache.statkart.no/gatekeeper/gk/gk.open_nib_utm33_wmts_v2';
	dim.wmtsLayer='Nibcache_UTM33_EUREF89_v2';
	console.log('Rettet!\nUrl: ' + dim.wmtsUrl + '\nLayer: ' + dim.wmtsLayer);
};*/
var wmsLayers = getQueryVariable("LAYERS") || layers;
var threeDMap = new wxs3.ThreeDMap(wmsLayers, dim);

// Show error message if 3D map is null
errorCheck(threeDMap, 3);